=== contrib/xxhash/CMakeLists.txt ===
SET(XXHASHSRC xxhash.c)

ADD_LIBRARY(xxhash STATIC ${XXHASHSRC})
