=== src/cdb/CMakeLists.txt ===
# CDB support makefile
SET(CDBSRC				cdb_init.c
						cdb_find.c
						cdb_make.c)

ADD_LIBRARY(rspamd-cdb ${LINK_TYPE} ${CDBSRC})
TARGET_LINK_LIBRARIES(rspamd-cdb rspamd-util)
SET_TARGET_PROPERTIES(rspamd-cdb PROPERTIES VERSION ${RSPAMD_VERSION})
SET_TARGET_PROPERTIES(rspamd-cdb PROPERTIES COMPILE_FLAGS "-DRSPAMD_LIB")
IF(NO_SHARED MATCHES "OFF")
	INSTALL(TARGETS rspamd-cdb 
    	LIBRARY DESTINATION ${LIBDIR} 
    	PUBLIC_HEADER DESTINATION ${INCLUDEDIR})
ENDIF(NO_SHARED MATCHES "OFF")
