=== debian/changelog ===
rspamd (0.6.10) unstable; urgency=low

  * Initial release (Closes: #683746)

 -- Mikhail Gusarov <dottedmag@debian.org>  Wed, 13 Aug 2014 00:28:21 +0200
